  Program
Level:Benign Equate( 0 )  
  map
    showJobInfo()
  end
Include('EnumPtr.inc')
EnumPrtCl            EnumPrtClType
  code
  ShowJobInfo()


ShowJobInfo                 Procedure( )
NewJobInfoQ                 NewJobInfoQType   !queue to display - info copied into it on event:notify
JobNotificationClass        &JobNotificationClassType  !wrapper for a NewJobInfoQ queue
NCode                       long, auto !not used but required by the notification function
lpJobNotificationClass      long, auto !pointer to the jobnotificationclass that comes via notify
edebugOn                    equate( 1 )
eDebugOff                   equate( 0 )
debugMode                   equate( eDebugOn )

Window WINDOW('Print Job Info'),AT(,,524,173),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:ANSI),SYSTEM, |
         GRAY,DOUBLE
       LIST,AT(13,13,500,129),USE(?List1),HVSCROLL,FORMAT('49L(2)|M~JobID~@N_10@#1#167L(2)|M~Description~@S40@#2#1500L(2)|M~Value~@S255@#3#'), |
           FROM(NewJobInfoQ)
       BUTTON('&Stop Monitoring'),AT(199,150,92,14),USE(?Button1),DISABLE
       END

  code

  
  !now show your queuue
  Open( window )
  display()
  Accept
    CASE EVENT()
    Of Event:openwindow
      EnumPrtCl.Init( DebugMode )
      EnumPrtCl.PrinterNotifications( Thread() )
      enable( ?Button1 )

    Of Event:CloseWindow
      EnumPrtCl.Kill()
      
      
    Of Event:Accepted
       case Field()
       of ?button1
         Post( Event:CloseWindow )
       end
      
      
    of Event:Notify
      If Notification( NCode, , lpJobNotificationClass )
        If ~lpJobNotificationClass then Cycle; end !bad data via notify
        JobNotificationClass &= ( lpJobNotificationClass )
        Do CopyJobInfo !copy new info into the list box
        
        !see if this is a new job
        get( JobNotificationClass.NewJobInfoQ, 1 )
        If JobNotificationClass.NewJobInfoQ.ResumeRequired

          !!! ---------------- New Job - do your thing below --------------- !!!
          Message(' Answer my questions before I let your print job continue!' )
          !!! ---------------- New Job - do your thing above --------------- !!!

          !resume the job
          If EnumPrtCl.ResumeJob( JobNotificationClass.NewJobInfoQ.hprinter, JobNotificationClass.NewJobInfoQ.JobID ) <> Level:Benign
            Message( clip( EnumPrtCl.ErrorStr ) )
          end
          
          !could log pages when total pages is not zero or log errors or not
            
        end
        
        !cleanup data received by notify
        dispose( JobNotificationClass.NewJobInfoQ )   !allocated by the api monitor thread
        dispose( JobNotificationClass )               !aloocated by our api monitor thread
      end
    END
  End
  Close( window )
  Return

CopyJobInfo Routine
  data
I                           long, auto !loop counter
Recs                        long, auto !upper limit for loop - records in a q
  code
  !copy JobNotificationClass.NewJobInfoQ into the displayed queue
  recs = Records( JobNotificationClass.NewJobInfoQ )
  Loop I = 1 to Recs
    get( JobNotificationClass.NewJobInfoQ, I )
     
    !see if we have this job attribute for this job or not
    NewJobInfoQ.JobID     = JobNotificationClass.NewJobInfoQ.JobID
    NewJobInfoQ.JobAttrib = JobNotificationClass.NewJobInfoQ.JobAttrib
    Get( NewJobInfoQ, NewJobInfoQ.JobID, NewJobInfoQ.JobAttrib )
    If ErrorCode() then
      
      !nope - dont have this one yet so ADD
      NewJobInfoQ = JobNotificationClass.NewJobInfoQ
      Add( NewJobInfoQ, NewJobInfoQ.JobID, NewJobInfoQ.JobAttrib )
      If errorcode()
        Message('Out of memory - update info lost.')
      end
    else
      
      !yep - we have this one so just update
      NewJobInfoQ = JobNotificationClass.NewJobInfoQ
      Put( NewJobInfoQ )
    end
    Select( ?List1, pointer( NewJobInfoQ ) )
    display()
  end
  Exit
  